using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserCarts;
namespace CMSMicroservice.Protobuf.Validator.UserCarts;

public class GetUserCartRequestValidator : AbstractValidator<GetUserCartRequest>
{
    public GetUserCartRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetUserCartRequest>.CreateWithOptions((GetUserCartRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
